<template>
  <div class="d-flex flex-column align-items-center">
    <div class="d-flex form-container">
      <div class="registration-form p-4 border rounded shadow">
        <password-reset-wizard-expired
          v-if="status === Status.EXPIRED"
          @success="status = Status.SENT"
        />
        <password-reset-wizard-request
          v-if="status === Status.REQUEST"
          @success="status = Status.SENT"
        />
        <password-reset-wizard-sent v-if="status === Status.SENT" />
        <password-reset-wizard-submit
          v-if="status === Status.SUBMIT"
          :token="$route.query.token"
          @success="status = Status.FINISHED"
        />
        <password-reset-wizard-finished v-if="status === Status.FINISHED" />
        <hr>
        <b-button
          :to="{ name: 'login', query: $route.query }"
          block
          variant="primary"
        >
          Return to login
        </b-button>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import jwtDecode from 'jwt-decode';
import PasswordResetWizardExpired from '@/components/PasswordResetWizardExpired.vue';
import PasswordResetWizardFinished from '@/components/PasswordResetWizardFinished.vue';
import PasswordResetWizardRequest from '@/components/PasswordResetWizardRequest.vue';
import PasswordResetWizardSent from '@/components/PasswordResetWizardSent.vue';
import PasswordResetWizardSubmit from '@/components/PasswordResetWizardSubmit.vue';

/* eslint-disable-next-line no-shadow */
enum Status {
  EXPIRED = 'EXPIRED',
  FINISHED = 'FINISHED',
  REQUEST = 'REQUEST',
  SENT = 'SENT',
  SUBMIT = 'SUBMIT',
}

export default Vue.extend({
  components: {
    PasswordResetWizardExpired,
    PasswordResetWizardFinished,
    PasswordResetWizardRequest,
    PasswordResetWizardSent,
    PasswordResetWizardSubmit,
  },

  data() {
    return {
      Status,
      status: Status.REQUEST,
    };
  },

  mounted() {
    if (this.$route.query.token) {
      if (this.validateToken(<string> this.$route.query.token)) {
        this.status = Status.SUBMIT;
      } else {
        this.status = Status.EXPIRED;
      }
    }
  },

  methods: {
    validateToken(token: string) {
      try {
        return (<any>jwtDecode(token)).exp >= Date.now() / 1000;
      } catch {
        return false;
      }
    },
  },
});
</script>

<style scoped>
.form-container {
  margin-top: 70px;
}
.registration-description {
  margin-right: 1em;
}
.registration-description {
  font-family: Arial, Helvetica, sans-serif;
  font-weight: bolder;
  font-variant: small-caps;
  font-size: 4em;
  color: darkslategray;
}
.registration-form {
  width: 400px;
}
</style>
